;
;
; I won't decieve you. RIAAC means "routine, irritating and annoying code".
;
;

Func ParseXML($path)
	$xml_handle=FileOpen($path, 0)
	$xml_file=FileRead($xml_handle, FileGetSize($path))
	FileClose($xml_handle)
	$xml_id=StringRegExp($xml_file, '<CHAR Id="(.*)">', 3)
	$xml_h_position=StringRegExp($xml_file, '<Position>(.*)</Position>', 3)
	$xml_h_rotation=StringRegExp($xml_file, '<Rotation>(.*)</Rotation>', 3)
	$xml_osd_flag=StringRegExp($xml_file, '<Flags>(.*)</Flags>' & @CRLF & '                <Class>', 3)
	$xml_osd_class=StringRegExp($xml_file, '<Class>(.*)</Class>', 3)
	$xml_osd_name=StringRegExp($xml_file, '<Name>(.*)</Name>', 3)
	$xml_osd_weapon=StringRegExp($xml_file, '<Weapon>(.*)</Weapon>', 3)
	$xml_osd_s_spawn=StringRegExp($xml_file, '<Spawn>(.*)</Spawn>', 3)
	$xml_osd_s_die=StringRegExp($xml_file, '<Die>(.*)</Die>', 3)
	$xml_osd_s_combat=StringRegExp($xml_file, '<Combat>(.*)</Combat>', 3)
	$xml_osd_s_alarm=StringRegExp($xml_file, '<Alarm>(.*)</Alarm>', 3)
	$xml_osd_s_hurt=StringRegExp($xml_file, '<Hurt>(.*)</Hurt>', 3)
	$xml_osd_s_defeated=StringRegExp($xml_file, '<Defeated>(.*)</Defeated>', 3)
	$xml_osd_s_ooa=StringRegExp($xml_file, '<OutOfAmmo>(.*)</OutOfAmmo>', 3)
	$xml_osd_addhp=StringRegExp($xml_file, '<AdditionalHealth>(.*)</AdditionalHealth>', 3)
	$xml_osd_j_type=StringRegExp($xml_file, '<Type>(.*)</Type>', 3)
	$xml_osd_j_ppid=StringRegExp($xml_file, '<PatrolPathId>(.*)</PatrolPathId>', 3)
	$xml_osd_b_combatid=StringRegExp($xml_file, '<CombatId>(.*)</CombatId>', 3)
	$xml_osd_b_meleeid=StringRegExp($xml_file, '<MeleeId>(.*)</MeleeId>', 3)
	$xml_osd_b_neutralid=StringRegExp($xml_file, '<NeutralId>(.*)</NeutralId>', 3)
	$xml_osd_i_a_use=StringRegExp($xml_file, '<Ammo>' & @CRLF & '                        <Use>(.*)</Use>', 3)
	$xml_osd_i_a_drop=StringRegExp($xml_file, '<Drop>(.*)</Drop>' & @CRLF & '                    </Ammo>', 3)
	$xml_osd_i_e_use=StringRegExp($xml_file, '<EnergyCell>' & @CRLF & '                        <Use>(.*)</Use>', 3)
	$xml_osd_i_e_drop=StringRegExp($xml_file, '<Drop>(.*)</Drop>' & @CRLF & '                    </EnergyCell>', 3)
	$xml_osd_i_h_use=StringRegExp($xml_file, '<Hypo>' & @CRLF & '                        <Use>(.*)</Use>', 3)
	$xml_osd_i_h_drop=StringRegExp($xml_file, '<Drop>(.*)</Drop>' & @CRLF & '                    </Hypo>', 3)
	$xml_osd_i_s_use=StringRegExp($xml_file, '<Shield>' & @CRLF & '                        <Use>(.*)</Use>', 3)
	$xml_osd_i_s_drop=StringRegExp($xml_file, '<Drop>(.*)</Drop>' & @CRLF & '                    </Shield>', 3)
	$xml_osd_i_i_use=StringRegExp($xml_file, '<Invisibility>' & @CRLF & '                        <Use>(.*)</Use>', 3)
	$xml_osd_i_i_drop=StringRegExp($xml_file, '<Drop>(.*)</Drop>' & @CRLF & '                    </Invisibility>', 3)
	$xml_osd_team=StringRegExp($xml_file, '<Team>(.*)</Team>', 3)
	$xml_osd_initammo=StringRegExp($xml_file, '<AmmoPercentage>(.*)</AmmoPercentage>', 3)
	ConsoleWrite($xml_osd_initammo  + "\n")
	$xml_osd_a_init=StringRegExp($xml_file, '<Initial>(.*)</Initial>', 3)
	$xml_osd_a_min=StringRegExp($xml_file, '<Minimal>(.*)</Minimal>', 3)
	$xml_osd_a_jobst=StringRegExp($xml_file, '<JobStart>(.*)</JobStart>', 3)
	$xml_osd_a_invest=StringRegExp($xml_file, '<Investigate>(.*)</Investigate>', 3)
	$xml_osd_alarmg=StringRegExp($xml_file, '<AlarmGroups>(.*)</AlarmGroups>', 3)
	$xml_osd_p_strong=StringRegExp($xml_file, '<StrongUnseen>(.*)</StrongUnseen>', 3)
	$xml_osd_p_weak=StringRegExp($xml_file, '<WeakUnseen>(.*)</WeakUnseen>', 3)
	$xml_osd_p_strongs=StringRegExp($xml_file, '<StrongSeen>(.*)</StrongSeen>', 3)
	$xml_osd_p_weaks=StringRegExp($xml_file, '<WeakSeen>(.*)</WeakSeen>', 3)
	ListFill($xml_id, $xml_osd_name)
EndFunc

Func FillBlanks()
	$xyz1=StringSplit($xml_h_position[$i-1], ' ')
	GUICtrlSetData($position1, $xyz1[1])
	GUICtrlSetData($position2, $xyz1[2])
	GUICtrlSetData($position3, $xyz1[3])
	$xyz2=StringSplit($xml_h_rotation[$i-1], ' ')
	GUICtrlSetData($rotation1, $xyz2[1])
	GUICtrlSetData($rotation2, $xyz2[2])
	GUICtrlSetData($rotation3, $xyz2[3])
	UncheckAllFlags()
	If StringInStr($xml_osd_flag[$i-1], 'IsPlayer') <> 0 Then GUICtrlSetState($isplayer, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'RandomCostume') <> 0 Then GUICtrlSetState($randomcostume, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'NotInitiallyPresent') <> 0 Then GUICtrlSetState($notinitiallypresent, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'NonCombatant') <> 0 Then GUICtrlSetState($noncombatant, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'CanSpawnMultiple') <> 0 Then GUICtrlSetState($canspawnmultiple, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'WasSpawned') <> 0 Then GUICtrlSetState($wasspawned, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'Unkillable') <> 0 Then GUICtrlSetState($unkillable, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'InfiniteAmmo') <> 0 Then GUICtrlSetState($infiniteammo, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'Omniscient') <> 0 Then GUICtrlSetState($omniscient, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'HasLSI') <> 0 Then GUICtrlSetState($haslsi, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'Boss') <> 0 Then GUICtrlSetState($boss, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'UpgradeDifficulty') <> 0 Then GUICtrlSetState($upgradedifficulty, $GUI_CHECKED)
	If StringInStr($xml_osd_flag[$i-1], 'NoAutoDrop') <> 0 Then GUICtrlSetState($noautodrop, $GUI_CHECKED)
	GUICtrlSetData($name, $xml_osd_name[$i-1])
	GUICtrlSetData($class, $xml_osd_class[$i-1])
	GUICtrlSetData($weapon, $xml_osd_weapon[$i-1])
	GUICtrlSetData($addhp, $xml_osd_addhp[$i-1])
	GUICtrlSetData($team, '', '')
	GUICtrlSetData($team, $__TeamList, $xml_osd_team[$i-1])
	GUICtrlSetData($ammo, $xml_osd_initammo[$i-1])
	GUICtrlSetData($alarmg, MakeAlarmGroup($xml_osd_alarmg[$i-1]))
	GUICtrlSetData($s_spawn, $xml_osd_s_spawn[$i-1])
	GUICtrlSetData($s_die, $xml_osd_s_die[$i-1])
	GUICtrlSetData($s_combat, $xml_osd_s_combat[$i-1])
	GUICtrlSetData($s_alarm, $xml_osd_s_alarm[$i-1])
	GUICtrlSetData($s_hurt, $xml_osd_s_hurt[$i-1])
	GUICtrlSetData($s_defeat, $xml_osd_s_defeated[$i-1])
	GUICtrlSetData($s_ooa, $xml_osd_s_ooa[$i-1])
	GUICtrlSetData($j_type, '')
	GUICtrlSetData($j_type, $__JobTypes, $xml_osd_j_type[$i-1])
	GUICtrlSetData($j_patrolid, $xml_osd_j_ppid[$i-1])
	GUICtrlSetData($b_combat, $xml_osd_b_combatid[$i-1])
	GUICtrlSetData($b_melee, $xml_osd_b_meleeid[$i-1])
	GUICtrlSetData($b_neutral, $xml_osd_b_neutralid[$i-1])
	GUICtrlSetData($a_init, '')
	GUICtrlSetData($a_init, $__AlertLevels, $xml_osd_a_init[$i-1])
	GUICtrlSetData($a_min, '')
	GUICtrlSetData($a_min, $__AlertLevels, $xml_osd_a_min[$i-1])
	GUICtrlSetData($a_jstart, '')
	GUICtrlSetData($a_jstart, $__AlertLevels, $xml_osd_a_jobst[$i-1])
	GUICtrlSetData($a_invest, '')
	GUICtrlSetData($a_invest, $__AlertLevels, $xml_osd_a_invest[$i-1])
	GUICtrlSetData($p_strong, $xml_osd_p_strong[$i-1])
	GUICtrlSetData($p_strongs, $xml_osd_p_strongs[$i-1])
	GUICtrlSetData($p_weak, $xml_osd_p_weak[$i-1])
	GUICtrlSetData($p_weaks, $xml_osd_p_weaks[$i-1])
	GUICtrlSetData($i_ammo_use, $xml_osd_i_a_use[$i-1])
	GUICtrlSetData($i_ammo_drop, $xml_osd_i_a_drop[$i-1])
	GUICtrlSetData($i_ecell_use, $xml_osd_i_e_use[$i-1])
	GUICtrlSetData($i_ecell_drop, $xml_osd_i_e_drop[$i-1])
	GUICtrlSetData($i_hypo_use, $xml_osd_i_h_use[$i-1])
	GUICtrlSetData($i_hypo_drop, $xml_osd_i_h_drop[$i-1])
	GUICtrlSetData($i_shield_use, $xml_osd_i_s_use[$i-1])
	GUICtrlSetData($i_shield_drop, $xml_osd_i_s_drop[$i-1])
	GUICtrlSetData($i_invis_use, $xml_osd_i_i_use[$i-1])
	GUICtrlSetData($i_invis_drop, $xml_osd_i_i_drop[$i-1])
EndFunc

Func ReplaceAndWrite()
	For $i = 1 to UBound($xml_id)
		If $xml_id[$i-1] <> 'DELETED' Then
			$obj_write = $obj_tmpl[0]
			$obj_write = StringReplace($obj_write, "%ID%", $xml_id[$i-1])
			$obj_write = StringReplace($obj_write, "%POS%", $xml_h_position[$i-1])
			$obj_write = StringReplace($obj_write, "%ROT%", $xml_h_rotation[$i-1])
			$obj_write = StringReplace($obj_write, "%FLAGS%", $xml_osd_flag[$i-1])
			$obj_write = StringReplace($obj_write, "%CLASS%", $xml_osd_class[$i-1])
			$obj_write = StringReplace($obj_write, "%NAME%", $xml_osd_name[$i-1])
			$obj_write = StringReplace($obj_write, "%WEAPON%", $xml_osd_weapon[$i-1])
			$obj_write = StringReplace($obj_write, "%S_SPAWN%", $xml_osd_s_spawn[$i-1])
			$obj_write = StringReplace($obj_write, "%S_DIE%", $xml_osd_s_die[$i-1])
			$obj_write = StringReplace($obj_write, "%S_COMBAT%", $xml_osd_s_combat[$i-1])
			$obj_write = StringReplace($obj_write, "%S_ALARM%", $xml_osd_s_alarm[$i-1])
			$obj_write = StringReplace($obj_write, "%S_HURT%", $xml_osd_s_hurt[$i-1])
			$obj_write = StringReplace($obj_write, "%S_DEFEATED%", $xml_osd_s_defeated[$i-1])
			$obj_write = StringReplace($obj_write, "%S_OOA%", $xml_osd_s_ooa[$i-1])
			$obj_write = StringReplace($obj_write, "%ADD_HP%", $xml_osd_addhp[$i-1])
			$obj_write = StringReplace($obj_write, "%J_TYPE%", $xml_osd_j_type[$i-1])
			$obj_write = StringReplace($obj_write, "%J_PPID%", $xml_osd_j_ppid[$i-1])
			$obj_write = StringReplace($obj_write, "%B_COMBAT%", $xml_osd_b_combatid[$i-1])
			$obj_write = StringReplace($obj_write, "%B_MELEE%", $xml_osd_b_meleeid[$i-1])
			$obj_write = StringReplace($obj_write, "%B_NEUTRAL%", $xml_osd_b_neutralid[$i-1])
			$obj_write = StringReplace($obj_write, "%I_A_U%", $xml_osd_i_a_use[$i-1])
			$obj_write = StringReplace($obj_write, "%I_A_D%", $xml_osd_i_a_drop[$i-1])
			$obj_write = StringReplace($obj_write, "%I_E_U%", $xml_osd_i_e_use[$i-1])
			$obj_write = StringReplace($obj_write, "%I_E_D%", $xml_osd_i_e_drop[$i-1])
			$obj_write = StringReplace($obj_write, "%I_H_U%", $xml_osd_i_h_use[$i-1])
			$obj_write = StringReplace($obj_write, "%I_H_D%", $xml_osd_i_h_drop[$i-1])
			$obj_write = StringReplace($obj_write, "%I_S_U%", $xml_osd_i_s_use[$i-1])
			$obj_write = StringReplace($obj_write, "%I_S_D%", $xml_osd_i_s_drop[$i-1])
			$obj_write = StringReplace($obj_write, "%I_I_U%", $xml_osd_i_i_use[$i-1])
			$obj_write = StringReplace($obj_write, "%I_I_D%", $xml_osd_i_i_drop[$i-1])
			$obj_write = StringReplace($obj_write, "%TEAM%", $xml_osd_team[$i-1])
			$obj_write = StringReplace($obj_write, "%INIT_AMMO%", $xml_osd_initammo[$i-1])
			$obj_write = StringReplace($obj_write, "%A_INIT%", $xml_osd_a_init[$i-1])
			$obj_write = StringReplace($obj_write, "%A_MIN%", $xml_osd_a_min[$i-1])
			$obj_write = StringReplace($obj_write, "%A_JS%", $xml_osd_a_jobst[$i-1])
			$obj_write = StringReplace($obj_write, "%A_INV%", $xml_osd_a_invest[$i-1])
			$obj_write = StringReplace($obj_write, "%AG%", $xml_osd_alarmg[$i-1])
			$obj_write = StringReplace($obj_write, "%P_STRONG%", $xml_osd_p_strong[$i-1])
			$obj_write = StringReplace($obj_write, "%P_WEAK%", $xml_osd_p_weak[$i-1])
			$obj_write = StringReplace($obj_write, "%P_STRONGS%", $xml_osd_p_strongs[$i-1])
			$obj_write = StringReplace($obj_write, "%P_WEAKS%", $xml_osd_p_weaks[$i-1])
			$obj_write = StringReplace($obj_write, '%N%', @CRLF)
			FileWrite($outp, $obj_write)
		EndIf
	Next
EndFunc

Func Read($what)
	Return GUICtrlRead($what)
EndFunc

Func ListFill($_sIds, $_sNames)
	ClearAll()
	For $i = 1 To UBound($_sIds)
		$bots[$i]=GUICtrlCreateListViewItem($_sIds[$i-1] & '|' & $_sNames[$i-1], $bot_list)
	Next
EndFunc

Func UncheckAllFlags()
	GUICtrlSetState($isplayer, $GUI_UNCHECKED)
	GUICtrlSetState($randomcostume, $GUI_UNCHECKED)
	GUICtrlSetState($notinitiallypresent, $GUI_UNCHECKED)
	GUICtrlSetState($noncombatant, $GUI_UNCHECKED)
	GUICtrlSetState($canspawnmultiple, $GUI_UNCHECKED)
	GUICtrlSetState($wasspawned, $GUI_UNCHECKED)
	GUICtrlSetState($unkillable, $GUI_UNCHECKED)
	GUICtrlSetState($infiniteammo, $GUI_UNCHECKED)
	GUICtrlSetState($omniscient, $GUI_UNCHECKED)
	GUICtrlSetState($haslsi, $GUI_UNCHECKED)
	GUICtrlSetState($boss, $GUI_UNCHECKED)
	GUICtrlSetState($upgradedifficulty, $GUI_UNCHECKED)
	GUICtrlSetState($noautodrop, $GUI_UNCHECKED)
EndFunc

Func ClearAll()
	UncheckAllFlags()
	GUICtrlSetData($rotation1, '')
	GUICtrlSetData($rotation2, '')
	GUICtrlSetData($rotation3, '')
	GUICtrlSetData($position1, '')
	GUICtrlSetData($position2, '')
	GUICtrlSetData($position3, '')
	GUICtrlSetData($name, '')
	GUICtrlSetData($class, '')
	GUICtrlSetData($weapon, '')
	GUICtrlSetData($addhp, '')
	GUICtrlSetData($team, '')
	GUICtrlSetData($team, $__TeamList)
	GUICtrlSetData($ammo, '')
	GUICtrlSetData($alarmg, '')
	GUICtrlSetData($s_spawn, '')
	GUICtrlSetData($s_die, '')
	GUICtrlSetData($s_combat, '')
	GUICtrlSetData($s_alarm, '')
	GUICtrlSetData($s_hurt, '')
	GUICtrlSetData($s_defeat, '')
	GUICtrlSetData($s_ooa, '')
	GUICtrlSetData($j_type, '')
	GUICtrlSetData($j_type, $__JobTypes)
	GUICtrlSetData($j_patrolid, '')
	GUICtrlSetData($b_combat, '')
	GUICtrlSetData($b_melee, '')
	GUICtrlSetData($b_neutral, '')
	GUICtrlSetData($a_init, '')
	GUICtrlSetData($a_init, $__AlertLevels)
	GUICtrlSetData($a_min, '')
	GUICtrlSetData($a_min, $__AlertLevels)
	GUICtrlSetData($a_jstart, '')
	GUICtrlSetData($a_jstart, $__AlertLevels)
	GUICtrlSetData($a_invest, '')
	GUICtrlSetData($a_invest, $__AlertLevels)
	GUICtrlSetData($i_ammo_use, '')
	GUICtrlSetData($i_ammo_drop, '')
	GUICtrlSetData($i_ecell_use, '')
	GUICtrlSetData($i_ecell_drop, '')
	GUICtrlSetData($i_hypo_use, '')
	GUICtrlSetData($i_hypo_drop, '')
	GUICtrlSetData($i_shield_use, '')
	GUICtrlSetData($i_shield_drop, '')
	GUICtrlSetData($i_invis_use, '')
	GUICtrlSetData($i_invis_drop, '')
	For $i = 1 To 1023
		GUICtrlDelete($bots[$i])
		$bots[$i] = 0x7FFFFFF4
	Next
EndFunc

Func MakeAlarmGroup($_pAlarmGroup)
	Local $_sInside = Number($_pAlarmGroup)
	Local $_sOutString
	If $_pAlarmGroup = '' Or $_pAlarmGroup = '0' Then
		$_sOutString = 'NONE'
		Return $_sOutString
	Else
		For $i = 31 To 0 Step -1
			If ($_sInside - 2^$i >= 0) Then
				$_sInside -= 2^$i
				$_sOutString = $_sOutString & $i & ' | '
			EndIf
		Next
		Return StringTrimRight($_sOutString, 3)
	EndIf
EndFunc

Func MakeAlarmGroupBack($_pAlarmGroup)
	Local $_sInside = StringSplit($_pAlarmGroup, ' | ', 1)
	Local $_sOut, $_sOutNum
	If $_pAlarmGroup = 'NONE' Or $_pAlarmGroup = '0' Or $_pAlarmGroup = '' Then
		$_sOut = '0'
	Else
		For $i = 1 To $_sInside[0]
			$_sOutNum = $_sOutNum + 2^$_sInside[$i]
		Next
		$_sOut = String($_sOutNum)
	EndIf
	Return $_sOut
EndFunc

Func SaveCurrent($index)
	If $xml_id[$index-1] <> 'DELETED' Then
		$pos = Read($position1) & ' ' & Read($position2) & ' ' & Read($position3)
		$xml_h_position[$index-1] = $pos
		$rot = Read($rotation1) & ' ' & Read($rotation2) & ' ' & Read($rotation3)
		$xml_h_rotation[$index-1] = $rot

		If Read($isplayer) = 1 Then $flags = $flags & 'IsPlayer '
		If Read($randomcostume) = 1 Then $flags = $flags & 'RandomCostume '
		If Read($notinitiallypresent) = 1 Then $flags = $flags & 'NotInitiallyPresent '
		If Read($noncombatant) = 1 Then $flags = $flags & 'NonCombatant '
		If Read($canspawnmultiple) = 1 Then $flags = $flags & 'CanSpawnMultiple '
		If Read($wasspawned) = 1 Then $flags = $flags & 'WasSpawned '
		If Read($unkillable) = 1 Then $flags = $flags & 'Unkillable '
		If Read($infiniteammo) = 1 Then $flags = $flags & 'InfiniteAmmo '
		If Read($omniscient) = 1 Then $flags = $flags & 'Omniscient '
		If Read($haslsi) = 1 Then $flags = $flags & 'HasLSI '
		If Read($boss) = 1 Then $flags = $flags & 'Boss '
		If Read($upgradedifficulty) = 1 Then $flags = $flags & 'UpgradeDifficulty '
		If Read($noautodrop) = 1 Then $flags = $flags & 'NoAutoDrop '
		$flags = StringTrimRight($flags, 1)
		$xml_osd_flag[$index-1] = $flags
		$flags = ''

		$xml_osd_name[$index-1] = Read($name)
		GUICtrlSetData($bots[$index], $xml_id[$index-1] & '|' & $xml_osd_name[$index-1])
		$xml_osd_class[$index-1] = Read($class)
		$xml_osd_weapon[$index-1] = Read($weapon)
		$xml_osd_addhp[$index-1] = Read($addhp)
		$xml_osd_team[$index-1] = Read($team)
		$xml_osd_initammo[$index-1] = Read($ammo)
		$xml_osd_alarmg[$index-1] = MakeAlarmGroupBack(Read($alarmg))

		$xml_osd_s_spawn[$index-1] = Read($s_spawn)
		$xml_osd_s_die[$index-1] = Read($s_die)
		$xml_osd_s_combat[$index-1] = Read($s_combat)
		$xml_osd_s_alarm[$index-1] = Read($s_alarm)
		$xml_osd_s_hurt[$index-1] = Read($s_hurt)
		$xml_osd_s_defeated[$index-1] = Read($s_defeat)
		$xml_osd_s_ooa[$index-1] = Read($s_ooa)

		$xml_osd_j_type[$index-1] = Read($j_type)
		$xml_osd_j_ppid[$index-1] = Read($j_patrolid)

		$xml_osd_b_combatid[$index-1] = Read($b_combat)
		$xml_osd_b_meleeid[$index-1] = Read($b_melee)
		$xml_osd_b_neutralid[$index-1] = Read($b_neutral)

		$xml_osd_a_init[$index-1] = Read($a_init)
		$xml_osd_a_min[$index-1] = Read($a_min)
		$xml_osd_a_jobst[$index-1] = Read($a_jstart)
		$xml_osd_a_invest[$index-1] = Read($a_invest)

		$xml_osd_p_strong[$index-1] = Read($p_strong)
		$xml_osd_p_strongs[$index-1] = Read($p_strongs)
		$xml_osd_p_weak[$index-1] = Read($p_weak)
		$xml_osd_p_weaks[$index-1] = Read($p_weaks)

		$xml_osd_i_a_use[$index-1] = Read($i_ammo_use)
		$xml_osd_i_a_drop[$index-1] = Read($i_ammo_drop)
		$xml_osd_i_e_use[$index-1] = Read($i_ecell_use)
		$xml_osd_i_e_drop[$index-1] = Read($i_ecell_drop)
		$xml_osd_i_h_use[$index-1] = Read($i_hypo_use)
		$xml_osd_i_h_drop[$index-1] = Read($i_hypo_drop)
		$xml_osd_i_s_use[$index-1] = Read($i_shield_use)
		$xml_osd_i_s_drop[$index-1] = Read($i_shield_drop)
		$xml_osd_i_i_use[$index-1] = Read($i_invis_use)
		$xml_osd_i_i_drop[$index-1] = Read($i_invis_drop)
	EndIf
EndFunc

Func AddBot()
	$id_temp = String(Int(Random(20000, 60000)))
	_ArrayAdd($xml_id, $id_temp)
	_ArrayAdd($xml_h_position, '0 0 0')
	_ArrayAdd($xml_h_rotation, '0 0 0')
	_ArrayAdd($xml_osd_flag, 'NotInitiallyPresent')
	_ArrayAdd($xml_osd_name, 'NewBot')
	$bots[Ubound($xml_id)] = GUICtrlCreateListViewItem($xml_id[UBound($xml_id)-1] & '|NewBot', $bot_list)
	_ArrayAdd($xml_osd_class, 'konoko_generic')
	_ArrayAdd($xml_osd_weapon, '')
	_ArrayAdd($xml_osd_addhp, '0')
	_ArrayAdd($xml_osd_team, 'Konoko')
	_ArrayAdd($xml_osd_initammo, '0')
	_ArrayAdd($xml_osd_alarmg, '0')
	_ArrayAdd($xml_osd_s_spawn, '')
	_ArrayAdd($xml_osd_s_die, '')
	_ArrayAdd($xml_osd_s_combat, '')
	_ArrayAdd($xml_osd_s_alarm, '')
	_ArrayAdd($xml_osd_s_hurt, '')
	_ArrayAdd($xml_osd_s_defeated, '')
	_ArrayAdd($xml_osd_s_ooa, '')
	_ArrayAdd($xml_osd_j_type, 'None')
	_ArrayAdd($xml_osd_j_ppid, '0')
	_ArrayAdd($xml_osd_b_combatid, '0')
	_ArrayAdd($xml_osd_b_meleeid, '0')
	_ArrayAdd($xml_osd_b_neutralid, '0')
	_ArrayAdd($xml_osd_a_init, 'Low')
	_ArrayAdd($xml_osd_a_min, 'Low')
	_ArrayAdd($xml_osd_a_jobst, 'Low')
	_ArrayAdd($xml_osd_a_invest, 'Low')
	_ArrayAdd($xml_osd_p_strong, '0')
	_ArrayAdd($xml_osd_p_strongs, '0')
	_ArrayAdd($xml_osd_p_weak, '0')
	_ArrayAdd($xml_osd_p_weaks, '0')
	_ArrayAdd($xml_osd_i_a_use, '0')
	_ArrayAdd($xml_osd_i_a_drop, '0')
	_ArrayAdd($xml_osd_i_e_use, '0')
	_ArrayAdd($xml_osd_i_e_drop, '0')
	_ArrayAdd($xml_osd_i_h_use, '0')
	_ArrayAdd($xml_osd_i_h_drop, '0')
	_ArrayAdd($xml_osd_i_s_use, '0')
	_ArrayAdd($xml_osd_i_s_drop, '0')
	_ArrayAdd($xml_osd_i_i_use, '0')
	_ArrayAdd($xml_osd_i_i_drop, '0')
	GUICtrlSetState($bots[Ubound($xml_id)], $GUI_FOCUS)
	$msg = $bots[UBound($xml_id)]
EndFunc


Func DelBot($index)
	GUICtrlDelete($bots[$index])
	$xml_id[$index-1] = 'DELETED'
EndFunc
