#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icons\mukade2.ico
#AutoIt3Wrapper_outfile=bot_editor.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Comment=Author - demos_kratos
#AutoIt3Wrapper_Res_Description=Bot Editor ALPHA-DEV
#AutoIt3Wrapper_Res_Fileversion=1.0.0.54
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=y
#AutoIt3Wrapper_Run_Debug_Mode=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <GuiConstantsEx.au3>
#include <Array.au3>
#NoTrayIcon

Global $inf_ver = '1.0'
Global $menu_fill = ''
Global $bots[1025], $first = True, $UsingOniSplit, $LastIndex, $flags, $context_menu, $cmenu_save = 0x6666, $Deleted
Const $__TeamList = 'Konoko|TCTF|Syndicate|Neutral|SecurityGuard|RogueKonoko|Switzlerland|SyndicateAccessory'
Const $__JobTypes = 'None|Idle|Guard|Patrol|Teambattle'
Const $__AlertLevels = 'Lull|Low|Medium|High|Combat'

For $i = 1 To 1024
	$bots[$i] = 0x6666
Next

If FileExists("OniSplit.exe") Then
	$oni_allowed = "; BINACJBOCharacter.oni"
	$osp = @WorkingDir & '\OniSplit.exe'
Else
	$menu_fill = ".xml"
	$oni_allowed = ""
EndIf

If FileExists("xml.tmpl") = 0 Then
	MsgBox(0, "Warning", "XML Template not found. Exiting.")
	Exit
Else
	$tmpl = @WorkingDir & "\xml.tmpl"
EndIf


$Main = GUICreate('Bot Editor ' & $inf_ver, 900, 600)
	$menu_file = GUICtrlCreateMenu('File')
		$menu_file_open = GUICtrlCreateMenuItem('Open BINACJBOCharacter' & $menu_fill, $menu_file)
		$menu_file_save = GUICtrlCreateMenuItem('Save to XML', $menu_file)
		GUICtrlSetState(-1, $GUI_DISABLE)
		$menu_file_del = GUICtrlCreateMenuItem('Delete Selected Bot', $menu_file)
		GUICtrlSetState(-1, $GUI_DISABLE)
		$menu_file_add = GUICtrlCreateMenuItem('Add Bot', $menu_file)
		GUICtrlSetState(-1, $GUI_DISABLE)
		GUICtrlCreateMenuItem('', $menu_file)
		$menu_file_exit = GUICtrlCreateMenuItem('Exit', $menu_file)
	$menu_about = GUICtrlCreateMenu('About')
		$menu_about_m = GUICtrlCreateMenuItem('About Bot Editor ' & $inf_ver, $menu_about)



GUICtrlCreateGroup('Bot list', 20, 20, 215, 520)
	$bot_list=GUICtrlCreateListView('ID    |Bot Name    ', 32, 42, 190, 485)

GUICtrlCreateGroup('Position', 260, 20, 400, 70)
	GUICtrlCreateLabel('X:', 280, 50)
	$position1 = GUICtrlCreateInput('', 290, 48, 100, 20)
	GUICtrlCreateLabel('Y:', 400, 50)
	$position2 = GUICtrlCreateInput('', 410, 48, 100, 20)
	GUICtrlCreateLabel('Z:', 520, 50)
	$position3 = GUICtrlCreateInput('', 530, 48, 100, 20)

GUICtrlCreateGroup('Rotation', 260, 100, 400, 70)
	GUICtrlCreateLabel('X:', 280, 130)
	$rotation1 = GUICtrlCreateInput('', 290, 128, 100, 20)
	GUICtrlCreateLabel('Y:', 400, 130)
	$rotation2 = GUICtrlCreateInput('', 410, 128, 100, 20)
	GUICtrlCreateLabel('Z:', 520, 130)
	$rotation3 = GUICtrlCreateInput('', 530, 128, 100, 20)

GUICtrlCreateGroup('Flags', 260, 180, 400, 150)
	$isplayer = GUICtrlCreateCheckbox('IsPlayer', 280, 200)
	$randomcostume = GUICtrlCreateCheckbox('RandomCostume', 280, 220)
	$notinitiallypresent = GUICtrlCreateCheckbox('NotInitiallyPresent', 280, 240)
	$noncombatant = GUICtrlCreateCheckbox('NonCombatant', 280, 260)
	$canspawnmultiple = GUICtrlCreateCheckbox('CanSpawnMultiple', 280, 280)
	$wasspawned = GUICtrlCreateCheckbox('WasSpawned', 280, 300)
	$unkillable = GUICtrlCreateCheckbox('Unkillable', 430, 200)
	$infiniteammo = GUICtrlCreateCheckbox('InfiniteAmmo', 430, 220)
	$omniscient = GUICtrlCreateCheckbox('Omniscient', 430, 240)
	$haslsi = GUICtrlCreateCheckbox('HasLSI', 430, 260)
	$boss = GUICtrlCreateCheckbox('Boss', 430, 280)
	$upgradedifficulty = GUICtrlCreateCheckbox('UpgradeDifficulty', 430, 300)
	$noautodrop = GUICtrlCreateCheckbox('NoAutoDrop', 550, 200)

GUICtrlCreateGroup('Main', 260, 340, 195, 200)
	GUICtrlCreateLabel('Name:', 280, 360)
	$name = GUICtrlCreateInput('', 325, 358, 115, 20)
	GUICtrlCreateLabel('Class:', 280, 385)
	$class = GUICtrlCreateInput('', 325, 383, 115, 20)
	GUICtrlCreateLabel('Weapon:', 280, 410)
	$weapon = GUICtrlCreateInput('', 325, 408, 115, 20)
	GUICtrlCreateLabel('Add HP:', 280, 435)
	$addhp = GUICtrlCreateInput('', 325, 433, 115, 20)
	GUICtrlCreateLabel('Team:', 280, 460)
	$team = GUICtrlCreateCombo('', 325, 458, 115, 20)
	GUICtrlSetData(-1, $__TeamList)
	GUICtrlCreateLabel('Ammo:', 280, 485)
	$ammo = GUICtrlCreateInput('', 325, 483, 115, 20)
	GUICtrlCreateLabel('Alarms:', 280, 510)
	$alarmg = GUICtrlCreateInput('', 325, 508, 115, 20)

GUICtrlCreateGroup('Scripts', 465, 340, 195, 200)
	GUICtrlCreateLabel('Spawn:', 485, 360)
	$s_spawn = GUICtrlCreateInput('', 535, 358, 115, 20)
	GUICtrlCreateLabel('Die:', 485, 385)
	$s_die = GUICtrlCreateInput('', 535, 383, 115, 20)
	GUICtrlCreateLabel('Combat:', 485, 410)
	$s_combat = GUICtrlCreateInput('', 535, 408, 115, 20)
	GUICtrlCreateLabel('Alarm:', 485, 435)
	$s_alarm = GUICtrlCreateInput('', 535, 433, 115, 20)
	GUICtrlCreateLabel('Hurt:', 485, 460)
	$s_hurt = GUICtrlCreateInput('', 535, 458, 115, 20)
	GUICtrlCreateLabel('Defeat:', 485, 485)
	$s_defeat = GUICtrlCreateInput('', 535, 483, 115, 20)
	GUICtrlCreateLabel('NoAmmo:', 485, 510)
	$s_ooa = GUICtrlCreateInput('', 535, 508, 115, 20)



GUICtrlCreateGroup('Job', 670, 180, 195, 75)
	GUICtrlCreateLabel('Type:', 690, 200)
	$j_type = GUICtrlCreateCombo('', 740, 198, 115, 20)
	GUICtrlSetData($j_type, $__JobTypes)
	GUICtrlCreateLabel('Patrol ID:', 690, 225)
	$j_patrolid = GUICtrlCreateInput('', 740, 223, 115, 20)

GUICtrlCreateGroup('Behaviour IDs', 670, 265, 195, 50)
	GUICtrlCreateLabel('Combat:', 680, 287)
	$b_combat = GUICtrlCreateInput('', 720, 285, 20, 20)
	GUICtrlCreateLabel('Melee:', 742, 287)
	$b_melee = GUICtrlCreateInput('', 775, 285, 20, 20)
	GUICtrlCreateLabel('Neutral:', 797, 287)
	$b_neutral = GUICtrlCreateInput('', 835, 285, 20, 20)


GUICtrlCreateGroup('Alert', 670, 320, 195, 125)
	GUICtrlCreateLabel('Initial:', 680, 340)
	$a_init = GUICtrlCreateCombo('', 735, 338, 115, 20)
	GUICtrlSetData(-1, $__AlertLevels)
	GUICtrlCreateLabel('Minimal:', 680, 365)
	$a_min = GUICtrlCreateCombo('', 735, 363, 115, 20)
	GUICtrlSetData(-1, $__AlertLevels)
	GUICtrlCreateLabel('Job Start:', 680, 390)
	$a_jstart = GUICtrlCreateCombo('', 735, 388, 115, 20)
	GUICtrlSetData(-1, $__AlertLevels)
	GUICtrlCreateLabel('Investigate:', 680, 415)
	$a_invest = GUICtrlCreateCombo('', 735, 413, 115, 20)
	GUICtrlSetData(-1, $__AlertLevels)

GUICtrlCreateGroup('Pursuit', 670, 450, 195, 90)
	GUICtrlCreateLabel('Strong:', 680, 475)
	$p_strong = GUICtrlCreateInput('', 720, 473, 40, 20)
	GUICtrlCreateLabel('Weak:', 680, 505)
	$p_weak = GUICtrlCreateInput('', 720, 503, 40, 20)
	$p_lab_strongseen = GUICtrlCreateLabel('StrongS:', 765, 475)
	GUICtrlSetFont(-1, 8.5, 400, 4)
	GUICtrlSetTip(-1, 'Strong Seen')
	$p_strongs = GUICtrlCreateInput('', 810, 473, 40, 20)
	$p_lab_weakseen = GUICtrlCreateLabel('WeakS:', 765, 505)
	GUICtrlSetFont(-1, 8.5, 400, 4)
	GUICtrlSetTip(-1, 'Weak Seen')
	$p_weaks = GUICtrlCreateInput('', 810, 503, 40, 20)



GUICtrlCreateTab(690, 40, 155, 100, 0x0200)
	GUICtrlCreateTabItem('Ammo')
		GUICtrlCreateGroup('Inventory', 670, 20, 195, 150)
		GUICtrlCreateLabel('Use:', 710, 100)
		$i_ammo_use = GUICtrlCreateInput('', 735, 98, 25, 20)
		GUICtrlCreateLabel('Drop:', 762, 100)
		$i_ammo_drop = GUICtrlCreateInput('', 790, 98, 25, 20)
	GUICtrlCreateTabItem('Energy Cell')
		GUICtrlCreateGroup('Inventory', 670, 20, 195, 150)
		GUICtrlCreateLabel('Use:', 710, 100)
		$i_ecell_use = GUICtrlCreateInput('', 735, 98, 25, 20)
		GUICtrlCreateLabel('Drop:', 762, 100)
		$i_ecell_drop = GUICtrlCreateInput('', 790, 98, 25, 20)
	GUICtrlCreateTabItem('Hypo')
		GUICtrlCreateGroup('Inventory', 670, 20, 195, 150)
		GUICtrlCreateLabel('Use:', 710, 100)
		$i_hypo_use = GUICtrlCreateInput('', 735, 98, 25, 20)
		GUICtrlCreateLabel('Drop:', 762, 100)
		$i_hypo_drop = GUICtrlCreateInput('', 790, 98, 25, 20)
	GUICtrlCreateTabItem('Shield')
		GUICtrlCreateGroup('Inventory', 670, 20, 195, 150)
		GUICtrlCreateLabel('Use:', 710, 100)
		$i_shield_use = GUICtrlCreateInput('', 735, 98, 25, 20)
		GUICtrlCreateLabel('Drop:', 762, 100)
		$i_shield_drop = GUICtrlCreateInput('', 790, 98, 25, 20)
	GUICtrlCreateTabItem('Invisibility')
		GUICtrlCreateGroup('Inventory', 670, 20, 195, 150)
		GUICtrlCreateLabel('Use:', 710, 100)
		$i_invis_use = GUICtrlCreateInput('', 735, 98, 25, 20)
		GUICtrlCreateLabel('Drop:', 762, 100)
		$i_invis_drop = GUICtrlCreateInput('', 790, 98, 25, 20)
GUICtrlCreateTabItem("")
GUISetState()



While 1
	$msg = GUIGetMsg()
	Select
		Case $msg = $menu_file_add
			AddBot()
		Case $msg = $menu_file_save
			$__select = FileSaveDialog('Browse', @WorkingDir, 'BINA/OBJC:CHAR (BINACJBOCharacter.xml)', 16, 'BINACJBOCharacter.xml')
			If Not @error Then
				$xml_save_path = $__select
				If Not ($Deleted = 0) Then SaveCurrent($LastIndex)
				$template = FileRead($tmpl, FileGetSize($tmpl))
				$outp = FileOpen($xml_save_path, 2)
				FileWrite($outp, Chr(0xEF) & Chr(0xBB) & Chr(0xBF))
				$temp = StringRegExp($template, '#HEAD#(.*)#/HEAD#', 3)
				$head_tmpl = StringReplace($temp[0], '%N%', @CRLF)
				FileWrite($outp, $head_tmpl)
				$obj_tmpl = StringRegExp($template, "#OBJ#(.*)#/OBJ#", 3)
				ReplaceAndWrite()
				$temp = StringRegExp($template, "#END#(.*)#/END#", 3)
				$end_tmpl = StringReplace($temp[0], '%N%', @CRLF)
				FileWrite($outp, $end_tmpl)
				$first = True
				FileClose($outp)
				ParseXML($xml_save_path)
				MsgBox(0, 'OK', 'Saved')
			EndIf
		Case $msg = $menu_file_open
			$xml_file = 0
			$__select = FileOpenDialog("Browse", @WorkingDir, "BINA/OBJC:CHAR (BINACJBOCharacter.xml" & $oni_allowed & ")", 1)
			If Not @error Then
				If StringInStr($__select, '.oni') <> 0 Then
					RunWait($osp & ' -extract:xml "' & @TempDir & '" "' & $__select & '"')
					$xml_file_path = @TempDir & "\BINACJBOCharacter.xml"
				Else
					$xml_file_path = $__select
				EndIf
				GUICtrlSetState($menu_file_add, $GUI_ENABLE)
				GUICtrlSetState($menu_file_save, $GUI_ENABLE)
				$xml_handle=FileOpen($xml_file_path, 0)
				$xml_file=FileRead($xml_handle, FileGetSize($xml_file_path))
				FileClose($xml_handle)
				$xml_id=StringRegExp($xml_file, '<CHAR Id="(.*)">', 3)
				$xml_h_position=StringRegExp($xml_file, '<Position>(.*)</Position>', 3)
				$xml_h_rotation=StringRegExp($xml_file, '<Rotation>(.*)</Rotation>', 3)
				$xml_osd_flag=StringRegExp($xml_file, '<Flags>(.*)</Flags>' & @CRLF & '                <Class>', 3)
				$xml_osd_class=StringRegExp($xml_file, '<Class>(.*)</Class>', 3)
				$xml_osd_name=StringRegExp($xml_file, '<Name>(.*)</Name>', 3)
				$xml_osd_weapon=StringRegExp($xml_file, '<Weapon>(.*)</Weapon>', 3)
				$xml_osd_s_spawn=StringRegExp($xml_file, '<Spawn>(.*)</Spawn>', 3)
				$xml_osd_s_die=StringRegExp($xml_file, '<Die>(.*)</Die>', 3)
				$xml_osd_s_combat=StringRegExp($xml_file, '<Combat>(.*)</Combat>', 3)
				$xml_osd_s_alarm=StringRegExp($xml_file, '<Alarm>(.*)</Alarm>', 3)
				$xml_osd_s_hurt=StringRegExp($xml_file, '<Hurt>(.*)</Hurt>', 3)
				$xml_osd_s_defeated=StringRegExp($xml_file, '<Defeated>(.*)</Defeated>', 3)
				$xml_osd_s_ooa=StringRegExp($xml_file, '<OutOfAmmo>(.*)</OutOfAmmo>', 3)
				$xml_osd_addhp=StringRegExp($xml_file, '<AdditionalHealth>(.*)</AdditionalHealth>', 3)
				$xml_osd_j_type=StringRegExp($xml_file, '<Type>(.*)</Type>', 3)
				$xml_osd_j_ppid=StringRegExp($xml_file, '<PatrolPathId>(.*)</PatrolPathId>', 3)
				$xml_osd_b_combatid=StringRegExp($xml_file, '<CombatId>(.*)</CombatId>', 3)
				$xml_osd_b_meleeid=StringRegExp($xml_file, '<MeleeId>(.*)</MeleeId>', 3)
				$xml_osd_b_neutralid=StringRegExp($xml_file, '<NeutralId>(.*)</NeutralId>', 3)
				$xml_osd_i_a_use=StringRegExp($xml_file, '<Ammo>' & @CRLF & '                        <Use>(.*)</Use>', 3)
				$xml_osd_i_a_drop=StringRegExp($xml_file, '<Drop>(.*)</Drop>' & @CRLF & '                    </Ammo>', 3)
				$xml_osd_i_e_use=StringRegExp($xml_file, '<EnergyCell>' & @CRLF & '                        <Use>(.*)</Use>', 3)
				$xml_osd_i_e_drop=StringRegExp($xml_file, '<Drop>(.*)</Drop>' & @CRLF & '                    </EnergyCell>', 3)
				$xml_osd_i_h_use=StringRegExp($xml_file, '<Hypo>' & @CRLF & '                        <Use>(.*)</Use>', 3)
				$xml_osd_i_h_drop=StringRegExp($xml_file, '<Drop>(.*)</Drop>' & @CRLF & '                    </Hypo>', 3)
				$xml_osd_i_s_use=StringRegExp($xml_file, '<Shield>' & @CRLF & '                        <Use>(.*)</Use>', 3)
				$xml_osd_i_s_drop=StringRegExp($xml_file, '<Drop>(.*)</Drop>' & @CRLF & '                    </Shield>', 3)
				$xml_osd_i_i_use=StringRegExp($xml_file, '<Invisibility>' & @CRLF & '                        <Use>(.*)</Use>', 3)
				$xml_osd_i_i_drop=StringRegExp($xml_file, '<Drop>(.*)</Drop>' & @CRLF & '                    </Invisibility>', 3)
				$xml_osd_team=StringRegExp($xml_file, '<Team>(.*)</Team>', 3)
				$xml_osd_initammo=StringRegExp($xml_file, '<AmmoPercentage>(.*)</AmmoPercentage>', 3)
				$xml_osd_a_init=StringRegExp($xml_file, '<Initial>(.*)</Initial>', 3)
				$xml_osd_a_min=StringRegExp($xml_file, '<Minimal>(.*)</Minimal>', 3)
				$xml_osd_a_jobst=StringRegExp($xml_file, '<JobStart>(.*)</JobStart>', 3)
				$xml_osd_a_invest=StringRegExp($xml_file, '<Investigate>(.*)</Investigate>', 3)
				$xml_osd_alarmg=StringRegExp($xml_file, '<AlarmGroups>(.*)</AlarmGroups>', 3)
				$xml_osd_p_strong=StringRegExp($xml_file, '<StrongUnseen>(.*)</StrongUnseen>', 3)
				$xml_osd_p_weak=StringRegExp($xml_file, '<WeakUnseen>(.*)</WeakUnseen>', 3)
				$xml_osd_p_strongs=StringRegExp($xml_file, '<StrongSeen>(.*)</StrongSeen>', 3)
				$xml_osd_p_weaks=StringRegExp($xml_file, '<WeakSeen>(.*)</WeakSeen>', 3)
				ListFill($xml_id, $xml_osd_name)
			EndIf
			$msg = GUIGetMsg()
		Case $msg = $menu_about_m
			MsgBox(0x40040, 'About', 'Bot Editor ' & $inf_ver & @CRLF & @CRLF & 'Author - Demos_Kratos')
		Case $msg = $menu_file_del
			If $Deleted = 0 Then
				MsgBox(0, 'Warning', 'Please select the bot first')
			Else
				$Deleted = 0
				DelBot($LastIndex)
			EndIf
		Case $msg = $GUI_EVENT_CLOSE Or $msg = $menu_file_exit
			If FileExists("C:\OniSplit.exe") Then
				FileDelete($osp)
			EndIf
			If FileExists('C:\Temp\BINACJBOCharacter.xml') Then
				FileDelete("C:\Temp\BINACJBOCharacter.xml")
			EndIf
			ExitLoop
	EndSelect
	For $i = 1 To 1024
		If $msg = $bots[$i] Then
			If Not $first Then
				SaveCurrent($LastIndex)
			EndIf
			$Deleted = 1
			$LastIndex = $i
			FillBlanks()
			If $first Then
				$first = False
				GUICtrlSetState($menu_file_del, $GUI_ENABLE)
			EndIf
		EndIf
	Next
WEnd

#include "RIAAC.au3"
